/*
 Hardware Abstract Layer
 (c) 2005 Vadim Kushnir
*/
#ifndef _HAL_H
#define _HAL_H

#define MAX_MODELS      3
#define MAX_MODELS_I2C  8
#define I2C_PAGE_SIZE   64  // 24LC256
#define I2C_PAGE_BITS   6  // 24LC256

#define LCD_CS_PORT     PORTB
#define LCD_CS_DDR      DDRB
#define LCD_CS_BIT      6
#define LCD_DATA_PORT   PORTC
#define LCD_DATA_DDR    DDRC
#define LCD_DATA_BIT    6
#define LCD_CLK_PORT    PORTC
#define LCD_CLK_DDR     DDRC
#define LCD_CLK_BIT     5
#define MODUL_PORT      PORTE
#define MODUL_DDR       DDRE
#define MODUL_BIT       4
#define BEEPER_PORT     PORTB
#define BEEPER_DDR      DDRB
#define BEEPER_BIT      7

#define PWR_PORT        PORTE
#define PWR_DDR         DDRE
#define PWR_BIT         1

#define KBDRET_BIT0     PINA5   // Warning: defs is not used is source!
#define KBDRET_BIT1     PINA6
#define KBDRET_BIT2     PINA7
#define KBDRET_BIT3     PING2

#define KBDSCAN_BIT0    PORTC0  // Warning: defs is not used is source!
#define KBDSCAN_BIT1    PORTC1
#define KBDSCAN_BIT2    PORTC2
#define KBDSCAN_BIT3    PORTC3
#define KBDSCAN_BIT4    PORTC4
#define KBDSCAN_BIT5    PORTB4
#define KBDSCAN_BIT6    PORTB5

#define I2C_SCL_BIT     PORTD0  // Warning: defs is not used is source!
#define I2C_SDA_BIT     PORTD1

void initHW();
void lcd_init();
void lcd_send_byte(uchar data, char dataFlg);
void startADC(void);
void startModul(MODEL_SETTINGS *m);
void stopModul();
void initKBD();
void procKBD();
uchar getKeyStat();
uchar getKeyCode();
uchar getKey();
short getBattVoltage();
short getJoyVal(char joyNum);
char getFlyMode();
char isTcut();
char getSwitchState(char sw);

void beep(uchar freq, uchar duration);
void beepOver(uchar freq, uchar duration);

char loadModelE(MODEL_SETTINGS *m, char num);
char getModelNameE(char *s, char num);
char saveModelE(MODEL_SETTINGS *m, char num);

char loadESettings(GEN_SETTINGS *s);
char saveESettings(GEN_SETTINGS *s);

char uploadModel(MODEL_SETTINGS *m);
char downloadModel(MODEL_SETTINGS *m);

extern void readPageI2C(char *i2cptr, char *ramptr, char len); //asm
extern void writePageI2C(char *i2cptr, char *ramptr, char len); //asm

//extern uchar beepCnt;

#endif  // _HAL_H
